// A Bison parser, made by GNU Bison 3.0.2.

// Skeleton interface for Bison GLR parsers in C++

// Copyright (C) 2002-2013 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// C++ GLR parser skeleton written by Akim Demaille.

#ifndef YY_YY_IDLC_TIDLC_Y_HPP_INCLUDED
# define YY_YY_IDLC_TIDLC_Y_HPP_INCLUDED


#include <stdexcept>
#include <string>
#include <iostream>
#include "location.hh"

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif


namespace yy {
#line 52 "./idlc/tidlc_y.hpp" // glr.cc:329


  /// A Bison parser.
  class parser
  {
  public:
#ifndef YYSTYPE
    /// Symbol semantic values.
    union semantic_type
    {
    #line 37 "./idlc/tidlc.yy" // glr.cc:329

  tidl::Document* doc;
  tidl::Interface* interf;
  tidl::Declaration* decl;
  tidl::Declarations* decls;
  tidl::BaseType* b_type;
  tidl::ParameterType* p_type;
  tidl::Token* direction;
  tidl::Parameter* param;
  tidl::Parameters* params;
  tidl::Token* token;
  tidl::Structure* structure;
  tidl::Element* elm;
  tidl::Elements* elms;
  tidl::Block* blk;
  tidl::Attribute* attr;
  tidl::Attributes* attrs;

#line 82 "./idlc/tidlc_y.hpp" // glr.cc:329
    };
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m);
      location_type location;
    };

    /// Tokens.
    struct token
    {
      enum yytokentype
      {
        T_LEFT = 258,
        T_RIGHT = 259,
        T_COMMA = 260,
        T_SEMICOLON = 261,
        T_BRACE_OPEN = 262,
        T_BRACE_CLOSE = 263,
        T_IN = 264,
        T_OUT = 265,
        T_REF = 266,
        T_ASYNC = 267,
        T_META_OPEN = 268,
        T_META_CLOSE = 269,
        T_EQUAL = 270,
        T_DELEGATE = 271,
        T_UNKNOWN = 272,
        T_ID = 273,
        T_STRUCTURE = 274,
        T_INTERFACE = 275,
        T_CHAR = 276,
        T_SHORT = 277,
        T_INT = 278,
        T_LONG = 279,
        T_FLOAT = 280,
        T_DOUBLE = 281,
        T_VOID = 282,
        T_BUNDLE = 283,
        T_STRING = 284,
        T_BOOL = 285,
        T_LIST = 286,
        T_ARRAY = 287,
        T_VALUE = 288,
        T_SB_OPEN = 289,
        T_SB_CLOSE = 290
      };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Internal symbol number.
    typedef int symbol_number_type;

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef unsigned char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ();

      /// Copy constructor.
      basic_symbol (const basic_symbol& other);

      /// Constructor for valueless symbols.
      basic_symbol (typename Base::kind_type t,
                    const location_type& l);

      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    const semantic_type& v,
                    const location_type& l);

      ~basic_symbol ();

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& other);
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
      /// Default constructor.
      by_type ();

      /// Copy constructor.
      by_type (const by_type& other);

      /// The symbol type as needed by the constructor.
      typedef token_type kind_type;

      /// Constructor from (external) token numbers.
      by_type (kind_type t);

      /// Steal the symbol type from \a that.
      void move (by_type& that);

      /// The (internal) type number (corresponding to \a type).
      /// -1 when this symbol is empty.
      symbol_number_type type_get () const;

      /// The token.
      token_type token () const;

      enum { empty = 0 };

      /// The symbol type.
      /// -1 when this symbol is empty.
      token_number_type type;
    };

    /// "External" symbols: returned by the scanner.
    typedef basic_symbol<by_type> symbol_type;



    /// Build a parser object.
    parser (tidl::Parser* ps_yyarg);
    virtual ~parser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

    /// The current debugging stream.
    std::ostream& debug_stream () const;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);

  public:
    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

# if YYDEBUG
  public:
    /// \brief Report a symbol value on the debug stream.
    /// \param yytype       The token type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    virtual void yy_symbol_value_print_ (int yytype,
                                         const semantic_type* yyvaluep,
                                         const location_type* yylocationp);
    /// \brief Report a symbol on the debug stream.
    /// \param yytype       The token type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    virtual void yy_symbol_print_ (int yytype,
                                   const semantic_type* yyvaluep,
                                   const location_type* yylocationp);
  private:
    // Debugging.
    std::ostream* yycdebug_;
#endif


    // User arguments.
    tidl::Parser* ps;
  };



#ifndef YYSTYPE
# define YYSTYPE yy::parser::semantic_type
#endif
#ifndef YYLTYPE
# define YYLTYPE yy::parser::location_type
#endif


} // yy
#line 290 "./idlc/tidlc_y.hpp" // glr.cc:329


#endif // !YY_YY_IDLC_TIDLC_Y_HPP_INCLUDED
